SystemOrganization addCategory: #'SBE-Quinto'!

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell commentStamp: 'lb 1/2/2013 21:57' prior: 0!
A simple game called Quinto: The game board consists of a rectangular array of light yellow cells. When you click on one of the cells with the mouse, the four surrounding cells turn blue. Click again, and they toggle back to light yellow. The object of the game is to turn blue as many cells as possible.!

!SBECell methodsFor: 'initialization' stamp: 'lb 1/2/2013 22:30'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0 @ 0 corner: 16 @ 16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!SBECell methodsFor: 'accessing' stamp: 'lb 1/2/2013 23:03'!
mouseAction: aBlock 
	^ mouseAction := aBlock! !

!SBECell methodsFor: 'event handling' stamp: 'lb 1/2/2013 23:07'!
mouseUp: anEvent 
	mouseAction value! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame methodsFor: 'initialization' stamp: 'lb 1/2/2013 22:37'!
cellsPerSide
	"The number of cells along each side of the game"
	^ 10! !

!SBEGame methodsFor: 'initialization' stamp: 'lb 1/2/2013 22:29'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self
		bounds: (5 @ 5 extent: width * n @ (height * n) + (2 * self borderWidth)).
	cells := Matrix
				new: n
				tabulate: [:i :j | self newCellAt: i at: j]! !

!SBEGame methodsFor: 'initialization' stamp: 'lb 1/2/2013 23:27'!
newCellAt: i at: j 
	"Create a cell for position (i,j) and add it to my on--screen
	representation at the appropriate screen position. Answer the new
	cell "
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: i - 1 * c width @ (j - 1 * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^ c! !

!SBEGame methodsFor: 'game logic' stamp: 'lb 1/2/2013 23:12'!
toggleNeighboursOfCellAt: i at: j 
	i > 1
		ifTrue: [(cells at: i - 1 at: j) toggleState].
	i < self cellsPerSide
		ifTrue: [(cells at: i + 1 at: j) toggleState].
	j > 1
		ifTrue: [(cells at: i at: j - 1) toggleState].
	j < self cellsPerSide
		ifTrue: [(cells at: i at: j + 1) toggleState]! !
